{
    "$graph": [
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "registry.gitlab.com/uc-cdis/genomel-primary-analysis/harmonization_with_bwa:1.0"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ResourceRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "type": "string",
                    "default": "tempfq",
                    "id": "#bam_to_fastq.cwl/T"
                },
                {
                    "type": "int",
                    "default": 1,
                    "id": "#bam_to_fastq.cwl/collate"
                },
                {
                    "type": "string",
                    "default": "QCFAIL,SECONDARY,SUPPLEMENTARY",
                    "id": "#bam_to_fastq.cwl/exclude"
                },
                {
                    "type": "File",
                    "id": "#bam_to_fastq.cwl/filename"
                },
                {
                    "type": "int",
                    "default": 1,
                    "id": "#bam_to_fastq.cwl/gz"
                },
                {
                    "type": "string",
                    "default": "bam",
                    "id": "#bam_to_fastq.cwl/inputformat"
                },
                {
                    "type": "string",
                    "id": "#bam_to_fastq.cwl/job_uuid"
                },
                {
                    "type": "int",
                    "default": 5,
                    "id": "#bam_to_fastq.cwl/level"
                },
                {
                    "type": "string",
                    "default": ".",
                    "id": "#bam_to_fastq.cwl/outputdir"
                },
                {
                    "type": "int",
                    "default": 1,
                    "id": "#bam_to_fastq.cwl/outputperreadgroup"
                },
                {
                    "type": "int",
                    "default": 1,
                    "id": "#bam_to_fastq.cwl/outputperreadgrouprgsm"
                },
                {
                    "type": "string",
                    "default": "_1.fq.gz",
                    "id": "#bam_to_fastq.cwl/outputperreadgroupsuffixF"
                },
                {
                    "type": "string",
                    "default": "_2.fq.gz",
                    "id": "#bam_to_fastq.cwl/outputperreadgroupsuffixF2"
                },
                {
                    "type": "string",
                    "default": "_o1.fq.gz",
                    "id": "#bam_to_fastq.cwl/outputperreadgroupsuffixO"
                },
                {
                    "type": "string",
                    "default": "_o2.fq.gz",
                    "id": "#bam_to_fastq.cwl/outputperreadgroupsuffixO2"
                },
                {
                    "type": "string",
                    "default": "_s.fq.gz",
                    "id": "#bam_to_fastq.cwl/outputperreadgroupsuffixS"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "id": "#bam_to_fastq.cwl/readgroup_lines"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "id": "#bam_to_fastq.cwl/readgroup_names"
                },
                {
                    "type": "int",
                    "default": 1,
                    "id": "#bam_to_fastq.cwl/tryoq"
                }
            ],
            "baseCommand": [],
            "arguments": [
                {
                    "position": 0,
                    "shellQuote": false,
                    "valueFrom": "/usr/bin/time -f \\\"{\\\"real_time\\\": \\\"%E\\\", \\\"user_time\\\": %U, \\\"system_time\\\": %S, \\\"wall_clock\\\": %e, \\\"maximum_resident_set_size\\\": %M, \\\"average_total_mem\\\": %K, \\\"percent_of_cpu\\\": \\\"%P\\\"}\\\" -o $(inputs.job_uuid + '.SamtoolsViewBam_BammToFastq' + '.time.json') samtools view -@ 8 -Shb $(inputs.filename.path) | /opt/biobambam2/2.0.87-release-20180301132713/x86_64-etch-linux-gnu/bin/bamtofastq collate=$(inputs.collate) exclude=$(inputs.exclude) filename=/dev/stdin gz=$(inputs.gz) inputformat=$(inputs.inputformat) level=$(inputs.level) outputdir=$(inputs.outputdir) outputperreadgroup=$(inputs.outputperreadgroup) outputperreadgrouprgsm=$(inputs.outputperreadgrouprgsm) outputperreadgroupsuffixF=$(inputs.outputperreadgroupsuffixF) outputperreadgroupsuffixF2=$(inputs.outputperreadgroupsuffixF2) outputperreadgroupsuffixO=$(inputs.outputperreadgroupsuffixO) outputperreadgroupsuffixO2=$(inputs.outputperreadgroupsuffixO2) outputperreadgroupsuffixS=$(inputs.outputperreadgroupsuffixS) tryoq=$(inputs.tryoq) T=$(inputs.T)"
                }
            ],
            "id": "#bam_to_fastq.cwl",
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*_1.fq.gz",
                        "outputEval": "${ return self.sort(function(a,b) { return a.location > b.location ? 1 : (a.location < b.location ? -1 : 0) }) }\n"
                    },
                    "id": "#bam_to_fastq.cwl/output_fastq1"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*_2.fq.gz",
                        "outputEval": "${ return self.sort(function(a,b) { return a.location > b.location ? 1 : (a.location < b.location ? -1 : 0) }) }\n"
                    },
                    "id": "#bam_to_fastq.cwl/output_fastq2"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "outputBinding": {
                        "outputEval": "${ return inputs.readgroup_lines.sort(function(a,b) { return a > b ? 1 : (a < b ? -1 : 0) }) }\n"
                    },
                    "id": "#bam_to_fastq.cwl/output_readgroup_lines"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "outputBinding": {
                        "outputEval": "${ return inputs.readgroup_names.sort(function(a,b) { return a > b ? 1 : (a < b ? -1 : 0) }) }\n"
                    },
                    "id": "#bam_to_fastq.cwl/output_readgroup_names"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.job_uuid + '.SamtoolsViewBam_BammToFastq' + '.time.json')"
                    },
                    "id": "#bam_to_fastq.cwl/time_metrics"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "registry.gitlab.com/uc-cdis/genomel-primary-analysis/harmonization_with_bwa:1.0"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "doc": "FASTQ file for input read (read R1 in Paired End mode)",
                    "id": "#bwa_mem.cwl/input_read1_fastq_file"
                },
                {
                    "type": "File",
                    "doc": "FASTQ file for read R2 in Paired End mode, if there is one.",
                    "id": "#bwa_mem.cwl/input_read2_fastq_file"
                },
                {
                    "type": "string",
                    "id": "#bwa_mem.cwl/job_uuid"
                },
                {
                    "type": "string",
                    "doc": "Specifies the readgroup. (e.g. \"@RG\\tCN:\\tPL:\\tID:\\tSM:\\tPU:\\tLB:\")",
                    "id": "#bwa_mem.cwl/readgroup_line"
                },
                {
                    "type": "string",
                    "doc": "Name of the output file.",
                    "id": "#bwa_mem.cwl/readgroup_name"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".fai",
                        ".64.amb",
                        ".64.ann",
                        ".64.bwt",
                        ".64.pac",
                        ".64.sa",
                        "^.dict",
                        ".amb",
                        ".ann",
                        ".bwt",
                        ".pac",
                        ".sa"
                    ],
                    "id": "#bwa_mem.cwl/reference"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "doc": "BWA BAM output file.",
                    "outputBinding": {
                        "glob": "*bam"
                    },
                    "id": "#bwa_mem.cwl/readgroup_bam"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.job_uuid + '.BWA_mem_' + inputs.readgroup_name + '_SamblasterDedup' + '.time.json')"
                    },
                    "id": "#bwa_mem.cwl/time_metrics"
                }
            ],
            "baseCommand": [],
            "arguments": [
                {
                    "position": 0,
                    "shellQuote": false,
                    "valueFrom": "/usr/bin/time -f \\\"{\\\"real_time\\\": \\\"%E\\\", \\\"user_time\\\": %U, \\\"system_time\\\": %S, \\\"wall_clock\\\": %e, \\\"maximum_resident_set_size\\\": %M, \\\"average_total_mem\\\": %K, \\\"percent_of_cpu\\\": \\\"%P\\\"}\\\" -o $(inputs.job_uuid + '.BWA_mem_' + inputs.readgroup_name + '_SamblasterDedup' + '.time.json') /opt/bwa-0.7.17/bwa mem -K 100000000 -M -v 3 -t 30 -Y $(inputs.reference.path) -R '$(inputs.readgroup_line)' $(inputs.input_read1_fastq_file.path) $(inputs.input_read2_fastq_file.path) | /opt/samblaster-v.0.1.24/samblaster -M -i /dev/stdin -o /dev/stdout | /opt/sambamba-0.6.8-linux-static view -t 30 -f bam -l 0 -S /dev/stdin | /opt/sambamba-0.6.8-linux-static sort -t 30 --natural-sort -m 15GiB --tmpdir ./ -o $(inputs.readgroup_name).unsorted.bam -l 5 /dev/stdin"
                }
            ],
            "id": "#bwa_mem.cwl"
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "registry.gitlab.com/uc-cdis/genomel-primary-analysis/harmonization_with_bwa:1.0"
                },
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "MultipleInputFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "doc": "Input bam file",
                    "id": "#get_bam_new_header.cwl/bam"
                }
            ],
            "stdout": "new_header",
            "outputs": [
                {
                    "type": "File",
                    "id": "#get_bam_new_header.cwl/bam_new_header",
                    "outputBinding": {
                        "glob": "new_header"
                    }
                }
            ],
            "baseCommand": [],
            "arguments": [
                {
                    "valueFrom": "samtools view -H $(inputs.bam.path) | grep -v \"SN:phiX174\"",
                    "shellQuote": false
                }
            ],
            "id": "#get_bam_new_header.cwl"
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "registry.gitlab.com/uc-cdis/genomel-primary-analysis/harmonization_with_bwa:1.0"
                },
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "MultipleInputFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "id": "#get_readgroup_name.cwl/bam"
                }
            ],
            "stdout": "readgroups_header",
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "outputBinding": {
                        "glob": "readgroups_header",
                        "loadContents": true,
                        "outputEval": "${\n  var rg_line = [];\n  for (var i = 0; i < self[0].contents.trim().split('\\n').length; i++ ){\n    rg_line.push(self[0].contents.trim().split('\\n')[i])\n  };\n  return rg_line\n}\n"
                    },
                    "id": "#get_readgroup_name.cwl/readgroup_lines"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "outputBinding": {
                        "glob": "readgroups_header",
                        "loadContents": true,
                        "outputEval": "${\n  var rg_name = [];\n  for (var i = 0; i < self[0].contents.trim().split('\\n').length; i++ ){\n    rg_name.push(self[0].contents.trim().split('\\n')[i].split('\\t')[1].replace('ID:', '').replace(/\\#/g, '%2'))\n  };\n  return rg_name\n}\n"
                    },
                    "id": "#get_readgroup_name.cwl/readgroup_names"
                }
            ],
            "baseCommand": [],
            "arguments": [
                {
                    "valueFrom": "samtools view -H $(inputs.bam.path) | grep \"^@RG\"",
                    "shellQuote": false
                }
            ],
            "id": "#get_readgroup_name.cwl"
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "registry.gitlab.com/uc-cdis/genomel-primary-analysis/harmonization_with_bwa:1.0"
                }
            ],
            "inputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "inputBinding": {
                        "position": 1,
                        "shellQuote": false
                    },
                    "id": "#sambamba_merge.cwl/bams"
                },
                {
                    "type": "string",
                    "id": "#sambamba_merge.cwl/base_file_name"
                },
                {
                    "type": "string",
                    "id": "#sambamba_merge.cwl/job_uuid"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.bam",
                        "outputEval": "${\n    if(inputs.bams.length > 1) return self\n    else return inputs.bams\n}"
                    },
                    "id": "#sambamba_merge.cwl/merged_bam"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.job_uuid + '.SambambaMerge' + '.time.json')"
                    },
                    "id": "#sambamba_merge.cwl/time_metrics"
                }
            ],
            "baseCommand": [],
            "arguments": [
                {
                    "position": 0,
                    "shellQuote": false,
                    "valueFrom": "${\n    var time_cmd = \"/usr/bin/time -f \\\"{\\\"real_time\\\": \\\"%E\\\", \\\"user_time\\\": %U, \\\"system_time\\\": %S, \\\"wall_clock\\\": %e, \\\"maximum_resident_set_size\\\": %M, \\\"average_total_mem\\\": %K, \\\"percent_of_cpu\\\": \\\"%P\\\"}\\\" -o \" + inputs.job_uuid + \".SambambaMerge\" + \".time.json\"\n    if (inputs.bams.length != 1)\n     return time_cmd + \" /opt/sambamba-0.6.8-linux-static merge -t 32 \" + inputs.base_file_name + \".aligned.duplicates_marked.unsorted.bam\"\n    else return time_cmd + \" ls\"\n }"
                }
            ],
            "id": "#sambamba_merge.cwl"
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "registry.gitlab.com/uc-cdis/genomel-primary-analysis/harmonization_with_bwa:1.0"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "id": "#sambamba_sort.cwl/bam"
                },
                {
                    "type": "string",
                    "id": "#sambamba_sort.cwl/base_file_name"
                },
                {
                    "type": "string",
                    "id": "#sambamba_sort.cwl/job_uuid"
                },
                {
                    "type": "string",
                    "default": "aligned.duplicates_marked.sorted",
                    "id": "#sambamba_sort.cwl/suffix"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.bam"
                    },
                    "secondaryFiles": [
                        "^.bai"
                    ],
                    "format": "#sambamba_sort.cwl/BAM",
                    "id": "#sambamba_sort.cwl/sorted_bam"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.job_uuid + '.SambambaSort' + '.time.json')"
                    },
                    "id": "#sambamba_sort.cwl/time_metrics"
                }
            ],
            "baseCommand": [],
            "arguments": [
                {
                    "position": 0,
                    "shellQuote": false,
                    "valueFrom": "/usr/bin/time -f \\\"{\\\"real_time\\\": \\\"%E\\\", \\\"user_time\\\": %U, \\\"system_time\\\": %S, \\\"wall_clock\\\": %e, \\\"maximum_resident_set_size\\\": %M, \\\"average_total_mem\\\": %K, \\\"percent_of_cpu\\\": \\\"%P\\\"}\\\" -o $(inputs.job_uuid + '.SambambaSort' + '.time.json') /opt/sambamba-0.6.8-linux-static sort -t 32 -m 100G -o $(inputs.base_file_name).$(inputs.suffix).bam $(inputs.bam.path) && mv $(inputs.base_file_name).$(inputs.suffix).bam.bai $(inputs.base_file_name).$(inputs.suffix).bai"
                }
            ],
            "id": "#sambamba_sort.cwl"
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "registry.gitlab.com/uc-cdis/genomel-primary-analysis/harmonization_with_bwa:1.0"
                },
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "MultipleInputFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "id": "#samtools_reheader.cwl/bam"
                },
                {
                    "type": "File",
                    "id": "#samtools_reheader.cwl/interval_bed"
                },
                {
                    "type": "string",
                    "id": "#samtools_reheader.cwl/job_uuid"
                },
                {
                    "type": "File",
                    "id": "#samtools_reheader.cwl/new_header"
                }
            ],
            "stdout": "$(inputs.job_uuid + '.reheadered.bam')",
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.job_uuid + '.reheadered.bam')"
                    },
                    "id": "#samtools_reheader.cwl/reheadered_bam"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.job_uuid + '.SamtoolsFilter_Reheader' + '.time.json')"
                    },
                    "id": "#samtools_reheader.cwl/time_metrics"
                }
            ],
            "baseCommand": [],
            "arguments": [
                {
                    "shellQuote": false,
                    "valueFrom": "/usr/bin/time -f \\\"{\\\"real_time\\\": \\\"%E\\\", \\\"user_time\\\": %U, \\\"system_time\\\": %S, \\\"wall_clock\\\": %e, \\\"maximum_resident_set_size\\\": %M, \\\"average_total_mem\\\": %K, \\\"percent_of_cpu\\\": \\\"%P\\\"}\\\" -o $(inputs.job_uuid + '.SamtoolsFilter_Reheader' + '.time.json') samtools view -@ 32 -Shb -f 3 -L $(inputs.interval_bed.path) $(inputs.bam.path) -o $(inputs.bam.nameroot).filtered.bam && samtools reheader $(inputs.new_header.path) $(inputs.bam.nameroot).filtered.bam && rm $(inputs.bam.nameroot).filtered.bam"
                }
            ],
            "id": "#samtools_reheader.cwl"
        },
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                },
                {
                    "class": "MultipleInputFeatureRequirement"
                },
                {
                    "class": "ScatterFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "id": "#main/input_bam"
                },
                {
                    "type": "File",
                    "id": "#main/interval_bed"
                },
                {
                    "type": "string",
                    "id": "#main/job_uuid"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".fai",
                        ".64.amb",
                        ".64.ann",
                        ".64.bwt",
                        ".64.pac",
                        ".64.sa",
                        "^.dict",
                        ".amb",
                        ".ann",
                        ".bwt",
                        ".pac",
                        ".sa"
                    ],
                    "id": "#main/reference"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#main/bam_sort/sorted_bam",
                    "id": "#main/sorted_bam"
                },
                {
                    "type": "File",
                    "outputSource": "#main/bam_to_fastq/time_metrics",
                    "id": "#main/time_metrics_from_bam_to_fastq"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#main/bwa_mem_filter_dedup/time_metrics",
                    "id": "#main/time_metrics_from_bwa_mem_filter_dedup"
                },
                {
                    "type": "File",
                    "outputSource": "#main/readgroups_merge/time_metrics",
                    "id": "#main/time_metrics_from_merge"
                },
                {
                    "type": "File",
                    "outputSource": "#main/bam_reheader/time_metrics",
                    "id": "#main/time_metrics_from_reheader"
                },
                {
                    "type": "File",
                    "outputSource": "#main/bam_sort/time_metrics",
                    "id": "#main/time_metrics_from_sort"
                }
            ],
            "steps": [
                {
                    "run": "#samtools_reheader.cwl",
                    "in": [
                        {
                            "source": "#main/readgroups_merge/merged_bam",
                            "id": "#main/bam_reheader/bam"
                        },
                        {
                            "source": "#main/interval_bed",
                            "id": "#main/bam_reheader/interval_bed"
                        },
                        {
                            "source": "#main/job_uuid",
                            "id": "#main/bam_reheader/job_uuid"
                        },
                        {
                            "source": "#main/get_bam_new_header/bam_new_header",
                            "id": "#main/bam_reheader/new_header"
                        }
                    ],
                    "out": [
                        "#main/bam_reheader/reheadered_bam",
                        "#main/bam_reheader/time_metrics"
                    ],
                    "id": "#main/bam_reheader"
                },
                {
                    "run": "#sambamba_sort.cwl",
                    "in": [
                        {
                            "source": "#main/bam_reheader/reheadered_bam",
                            "id": "#main/bam_sort/bam"
                        },
                        {
                            "source": "#main/job_uuid",
                            "valueFrom": "$(self)",
                            "id": "#main/bam_sort/base_file_name"
                        },
                        {
                            "source": "#main/job_uuid",
                            "id": "#main/bam_sort/job_uuid"
                        }
                    ],
                    "out": [
                        "#main/bam_sort/sorted_bam",
                        "#main/bam_sort/time_metrics"
                    ],
                    "id": "#main/bam_sort"
                },
                {
                    "run": "#bam_to_fastq.cwl",
                    "in": [
                        {
                            "source": "#main/input_bam",
                            "id": "#main/bam_to_fastq/filename"
                        },
                        {
                            "source": "#main/job_uuid",
                            "id": "#main/bam_to_fastq/job_uuid"
                        },
                        {
                            "source": "#main/get_readgroup_info/readgroup_lines",
                            "id": "#main/bam_to_fastq/readgroup_lines"
                        },
                        {
                            "source": "#main/get_readgroup_info/readgroup_names",
                            "id": "#main/bam_to_fastq/readgroup_names"
                        }
                    ],
                    "out": [
                        "#main/bam_to_fastq/output_readgroup_lines",
                        "#main/bam_to_fastq/output_readgroup_names",
                        "#main/bam_to_fastq/output_fastq1",
                        "#main/bam_to_fastq/output_fastq2",
                        "#main/bam_to_fastq/time_metrics"
                    ],
                    "id": "#main/bam_to_fastq"
                },
                {
                    "run": "#bwa_mem.cwl",
                    "scatter": [
                        "#main/bwa_mem_filter_dedup/input_read1_fastq_file",
                        "#main/bwa_mem_filter_dedup/input_read2_fastq_file",
                        "#main/bwa_mem_filter_dedup/readgroup_line",
                        "#main/bwa_mem_filter_dedup/readgroup_name"
                    ],
                    "scatterMethod": "dotproduct",
                    "in": [
                        {
                            "source": "#main/bam_to_fastq/output_fastq1",
                            "id": "#main/bwa_mem_filter_dedup/input_read1_fastq_file"
                        },
                        {
                            "source": "#main/bam_to_fastq/output_fastq2",
                            "id": "#main/bwa_mem_filter_dedup/input_read2_fastq_file"
                        },
                        {
                            "source": "#main/job_uuid",
                            "id": "#main/bwa_mem_filter_dedup/job_uuid"
                        },
                        {
                            "source": "#main/bam_to_fastq/output_readgroup_lines",
                            "id": "#main/bwa_mem_filter_dedup/readgroup_line"
                        },
                        {
                            "source": "#main/bam_to_fastq/output_readgroup_names",
                            "id": "#main/bwa_mem_filter_dedup/readgroup_name"
                        },
                        {
                            "source": "#main/reference",
                            "id": "#main/bwa_mem_filter_dedup/reference"
                        }
                    ],
                    "out": [
                        "#main/bwa_mem_filter_dedup/readgroup_bam",
                        "#main/bwa_mem_filter_dedup/time_metrics"
                    ],
                    "id": "#main/bwa_mem_filter_dedup"
                },
                {
                    "run": "#get_bam_new_header.cwl",
                    "in": [
                        {
                            "source": "#main/readgroups_merge/merged_bam",
                            "id": "#main/get_bam_new_header/bam"
                        }
                    ],
                    "out": [
                        "#main/get_bam_new_header/bam_new_header"
                    ],
                    "id": "#main/get_bam_new_header"
                },
                {
                    "run": "#get_readgroup_name.cwl",
                    "in": [
                        {
                            "source": "#main/input_bam",
                            "id": "#main/get_readgroup_info/bam"
                        }
                    ],
                    "out": [
                        "#main/get_readgroup_info/readgroup_lines",
                        "#main/get_readgroup_info/readgroup_names"
                    ],
                    "id": "#main/get_readgroup_info"
                },
                {
                    "run": "#sambamba_merge.cwl",
                    "in": [
                        {
                            "source": "#main/bwa_mem_filter_dedup/readgroup_bam",
                            "id": "#main/readgroups_merge/bams"
                        },
                        {
                            "source": "#main/job_uuid",
                            "valueFrom": "$(self)",
                            "id": "#main/readgroups_merge/base_file_name"
                        },
                        {
                            "source": "#main/job_uuid",
                            "id": "#main/readgroups_merge/job_uuid"
                        }
                    ],
                    "out": [
                        "#main/readgroups_merge/merged_bam",
                        "#main/readgroups_merge/time_metrics"
                    ],
                    "id": "#main/readgroups_merge"
                }
            ],
            "id": "#main"
        }
    ],
    "cwlVersion": "v1.0"
}
